#include <kos.h>
#include <png/png.h>
#include "smashdc.h"
#include "vars.h"

void DrawItem( uint32 index, int xpos, int ypos, int width, int height );

void DrawItems()
{
	int i;

	for ( i=0; i<MAX_ENEMIES; i++ )
	{
		if ( Rooms[CurrentRoom].Items[i].Active == TRUE )
		{
			switch( Rooms[CurrentRoom].Items[i].Type )
			{
				case ITEM_1UP:
					DrawItem( Item1Up, Rooms[CurrentRoom].Items[i].XPos,
						Rooms[CurrentRoom].Items[i].YPos, 32, 32 );
					break;
				case ITEM_MINE:
					DrawItem( ItemMine, Rooms[CurrentRoom].Items[i].XPos,
						Rooms[CurrentRoom].Items[i].YPos, 32, 32 );
					break;
				case ITEM_ROCKET:
					DrawItem( ItemRocket, Rooms[CurrentRoom].Items[i].XPos,
						Rooms[CurrentRoom].Items[i].YPos, 32, 32 );
					break;
				case ITEM_MONEY:
					DrawItem( ItemMoney, Rooms[CurrentRoom].Items[i].XPos,
						Rooms[CurrentRoom].Items[i].YPos, 32, 32 );
					break;
				case ITEM_SILVER:
					DrawItem( ItemSilver, Rooms[CurrentRoom].Items[i].XPos,
						Rooms[CurrentRoom].Items[i].YPos, 32, 32 );
					break;
				case ITEM_GOLD:
					DrawItem( ItemGold, Rooms[CurrentRoom].Items[i].XPos,
						Rooms[CurrentRoom].Items[i].YPos, 32, 32 );
					break;
			}
		}
	}

}

void DrawItem( uint32 index, int xpos, int ypos, int width, int height )
{
  poly_hdr_t poly;
  vertex_ot_t vert;

  ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB1555_TWID, 16, 16, index, TA_NO_FILTER);
  ta_commit_poly_hdr(&poly);

  vert.r = vert.g = vert.b = 1.0f;
  vert.a = 1.0f;
  vert.oa = vert.or = vert.ob = 0.0f;
  vert.flags = TA_VERTEX_NORMAL;

  vert.x = xpos-(width/2);
  vert.y = ypos-(height/2);
  vert.z = 2;
  vert.u = 0.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+(width/2);
  vert.y = ypos-(height/2);
  vert.z = 2;
  vert.u = 1.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos-(width/2);
  vert.y = ypos+(height/2);
  vert.z = 2;
  vert.u = 0.0;
  vert.v = 1.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+(width/2);
  vert.y = ypos+(height/2);
  vert.z = 2;
  vert.u = 1.0;
  vert.v = 1.0;
  vert.flags = TA_VERTEX_EOL;
  ta_commit_vertex(&vert, sizeof(vert));
}
