#include <kos.h>
#include "smashdc.h"
#include "vars.h"

void DrawDigit( uint32 tex, int xpos, int ypos, int z );

void DrawNumber( char * number, int xpos, int ypos, int z )
{
	int i;
	int length=strlen(number);

	for ( i=0; i<length; i++ )
	{
		switch( number[i] )
		{
			case '0':
				DrawDigit( NumberTextures[0], xpos+(i*16), ypos, z );
				break;
			case '1':
				DrawDigit( NumberTextures[1], xpos+(i*16), ypos, z );
				break;
			case '2':
				DrawDigit( NumberTextures[2], xpos+(i*16), ypos, z );
				break;
			case '3':
				DrawDigit( NumberTextures[3], xpos+(i*16), ypos, z );
				break;
			case '4':
				DrawDigit( NumberTextures[4], xpos+(i*16), ypos, z );
				break;
			case '5':
				DrawDigit( NumberTextures[5], xpos+(i*16), ypos, z );
				break;
			case '6':
				DrawDigit( NumberTextures[6], xpos+(i*16), ypos, z );
				break;
			case '7':
				DrawDigit( NumberTextures[7], xpos+(i*16), ypos, z );
				break;
			case '8':
				DrawDigit( NumberTextures[8], xpos+(i*16), ypos, z );
				break;
			case '9':
				DrawDigit( NumberTextures[9], xpos+(i*16), ypos, z );
				break;
		}
	}
}

void DrawDigit( uint32 tex, int xpos, int ypos, int z )
{
  poly_hdr_t poly;
  vertex_ot_t vert;

  ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB1555_TWID, 32, 32, tex, TA_BILINEAR_FILTER);
  ta_commit_poly_hdr(&poly);

  vert.r = vert.g = vert.b = 1.0f;
  vert.a = 1.0f;
  vert.oa = vert.or = vert.ob = 0.0f;
  vert.flags = TA_VERTEX_NORMAL;

  vert.x = xpos;
  vert.y = ypos;
  vert.z = z;
  vert.u = 0.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+32;
  vert.y = ypos;
  vert.z = z;
  vert.u = 1.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos;
  vert.y = ypos+32;
  vert.z = z;
  vert.u = 0.0;
  vert.v = 1.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+32;
  vert.y = ypos+32;
  vert.z = z;
  vert.u = 1.0;
  vert.v = 1.0;
  vert.flags = TA_VERTEX_EOL;
  ta_commit_vertex(&vert, sizeof(vert));
}
