#include <kos.h>
#include <png/png.h>
#include <stdlib.h>
#include "smashdc.h"
#include "vars.h"

void DrawObject( uint32 spriteindex, int xpos, int ypos, int width, int height, int texwidth, int texheight );
void DrawBlankPoly( float r, float g, float b, float a );

void DoPause( int playerindex )
{
	int UnPause = FALSE;
	char buffer[10];

	while ( UnPause == FALSE )
	{
		UpdateControls();

		if ( ControlSets[playerindex].Exit == TRUE )
		{
			if ( StartPressed == FALSE )
			{
				UnPause=TRUE;

				while ( ControlSets[playerindex].Exit == TRUE )
				{ UpdateControls(); }
			}
		}
		else
			StartPressed=FALSE;

		ta_begin_render();
		DrawRoom();
		ta_commit_eol();
		DrawPlayers();
		DrawEnemies();
		DrawItems();
		DrawEffects();
		DrawPlayerBullets();
		DrawLifePanels();
		DrawOverlay( Overlays[Rooms[CurrentRoom].Overlay] );
		sprintf( buffer, "%d", Players[0].Lives );
		DrawNumber( buffer, 42, 50, 6 );
		sprintf( buffer, "%d", Players[1].Lives );
		DrawNumber( buffer, 115, 50, 6 );
		sprintf( buffer, "%d", Players[2].Lives );
		DrawNumber( buffer, 489, 50, 6 );
		sprintf( buffer, "%d", Players[3].Lives );
		DrawNumber( buffer, 561, 50, 6 );
		DrawBlankPoly( 1.0f, 1.0f, 1.0f, 0.75f );
		DrawObject( Map, 55, 150, 512, 256, 256, 256 );
		DrawObject( Player1, 25, 35, 128, 128, 128, 128 );
		sprintf( buffer, "%d", Players[0].Score );
		DrawNumber( buffer, 25, 60, 9 );
		DrawObject( Player2, 450, 35, 128, 128, 128, 128 );
		sprintf( buffer, "%d", Players[1].Score );
		DrawNumber( buffer, 450, 60, 9 );
		DrawObject( Player3, 25, 90, 128, 128, 128, 128 );
		sprintf( buffer, "%d", Players[2].Score );
		DrawNumber( buffer, 25, 120, 9 );
		DrawObject( Player4, 450, 90, 128, 128, 128, 128 );
		sprintf( buffer, "%d", Players[3].Score );
		DrawNumber( buffer, 450, 120, 9 );
		DrawObject( InRoom, 395, 432, 256, 256, 256, 256 );
		sprintf( buffer, "%d", CurrentRoom );
		DrawNumber( buffer, 580, 425, 9 );
		ta_commit_eol();
		ta_finish_frame();
	}
}

void DrawBlankPoly( float r, float g, float b, float a )
{
  poly_hdr_t poly;
  vertex_oc_t vert;

  ta_poly_hdr_col(&poly, TA_TRANSLUCENT );
  ta_commit_poly_hdr(&poly);

  vert.r = r;
  vert.g = g;
  vert.b = b;
  vert.a = a;
  vert.flags = TA_VERTEX_NORMAL;

  vert.x = 0;
  vert.y = 0;
  vert.z = 8;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = 640;
  vert.y = 0;
  vert.z = 8;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = 0;
  vert.y = 480;
  vert.z = 8;

  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = 640;
  vert.y = 480;
  vert.z = 8;
  vert.flags = TA_VERTEX_EOL;
  ta_commit_vertex(&vert, sizeof(vert));
}

void DrawObject( uint32 spriteindex, int xpos, int ypos, int width, int height, int texwidth, int texheight )
{
  poly_hdr_t poly;
  vertex_ot_t vert;

  ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB1555_TWID, texwidth, texheight, spriteindex, TA_NO_FILTER);
  ta_commit_poly_hdr(&poly);

  vert.r = vert.g = vert.b = 1.0f;
  vert.a = 1.0f;
  vert.oa = vert.or = vert.ob = 0.0f;
  vert.flags = TA_VERTEX_NORMAL;

  vert.x = xpos;
  vert.y = ypos;
  vert.z = 9;
  vert.u = 0.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+width;
  vert.y = ypos;
  vert.z = 9;
  vert.u = 1.0;
  vert.v = 0.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos;
  vert.y = ypos+height;
  vert.z = 9;
  vert.u = 0.0;
  vert.v = 1.0;
  ta_commit_vertex(&vert, sizeof(vert));

  vert.x = xpos+width;
  vert.y = ypos+height;
  vert.z = 9;
  vert.u = 1.0;
  vert.v = 1.0;
  vert.flags = TA_VERTEX_EOL;
  ta_commit_vertex(&vert, sizeof(vert));
}
